#include <stdio.h>
#include <math.h>

int main() {
  const float m = 0.1;    // kg
  const float g = 9.8;    // m/s^2
  const float h = 10.;    // m
  const float eta = 0.02; // N/(m/s)^2
  float t, dt, y, v, vm, a, F;

  FILE *fp;

  dt = 0.01;   // s
  y = h;
  v = 0;
  t = 0;

  fp = fopen("caduta_in_aria.txt", "w");
  
  printf("velocità limite: %f m/s\n\n", sqrt(m*g/eta));

  printf(" %f  %f  %f\n", t, y, v);
  fprintf(fp, " %f  %f  %f\n", t, y, v);
  
  F = -m*g + eta*(v*v);
  a = F/m;
  while (y > 0) {
    vm = v + a * dt/2.;
    F = -m*g + eta*(vm*vm);
    a = F/m;
    vm = v + a * dt/2.;
    v += a*dt;
    y += vm*dt;
    t = t + dt;
    printf(" %f  %f  %f\n", t, y, v);
    fprintf(fp, " %f  %f  %f\n", t, y, v);
  }

  fclose(fp);
  return 0;
} 
