

f <- function(x) sqrt(x)/sqrt(1+sin(x)^2)

plot(f, 0, pi/2, col='blue')

n <- 10000
x <- seq(0, pi/2, len=n+1)
dx <- pi/2/n
xc <- x[1:n] + dx/2

int1 <- sum(f(xc)*dx)
cat(sprintf("Integrale %d striscioline: %f\n", n, int1))

n <- 100000
x <- runif(n, 0, pi/2)
y <- runif(n, 0, f(pi/2))

n.in <- length(y[y<f(x)])
int2 <- n.in/n * pi/2 * f(pi/2)
cat(sprintf("Integrale da %d punti (dei quali %d 'sotto'): %f\n",
            n, n.in, int2))

cat(sprintf("Integrale usando integrate(): %f\n",
            integrate(f, 0, pi/2)$value ))
