#include <stdio.h>

void stampaMatriceF(int nr, int nc, float A[nr][nc]) {
  int i, j;
  for (i=0; i<nr; i++) {
    for (j=0; j<nc; j++) {
      printf("%4.0f ", A[i][j]); 
    }
    printf("\n");
  }
}

void swapRighe(int nr, int nc, float A[nr][nc], int r1, int r2) {
  int i;
  float tmp;
  for (i=0; i<nc; i++) {
    tmp = A[r1-1][i];            // sul motivo del '-1' vedi nota in fondo
    A[r1-1][i] = A[r2-1][i];
    A[r2-1][i] = tmp;
  }
}

void swapColonne(int nr, int nc, float A[nr][nc], int c1, int c2) {
  int i;
  float tmp;
  for (i=0; i<nc; i++) {
    tmp = A[i][c1-1];
    A[i][c1-1] = A[i][c2-1];
    A[i][c2-1] = tmp;
  }
}

int main() {
  int i, j, nr=10, nc=10;
  float A[nr][nc];

  for (i=0; i<nr; i++) {
    for (j=0; j<nc; j++) {
      A[i][j] = (i+1)*(j+1);
    }
  }

  stampaMatriceF(nr, nc, A);
  puts(" ");
  swapRighe(nr, nc, A, 3, 7);
  stampaMatriceF(nr, nc, A);
  puts(" ");
  swapColonne(nr, nc, A, 2, 8);
  stampaMatriceF(nr, nc, A);
  
  return 0;
}

/* Nella traccia si invitava a fare 
     "Attenzione a non confondere l'usuale numerazioni
      di righe e colonne della matematica con quella
      degli indici degli array del linguaggio C"
   quindi per riga 3 si intendeva veramente la terza riga. 
   Ovviamente si poteva ottenere lo stesso risultato senza
   i vari '-1', ma chiamando le funzioni con gli indici 
   corrispondenti alle righe e colonne, ad esempio
      swapRighe(nr, nc, A, 3-1, 7-1);
   [meglio di swapRighe(nr, nc, A, 2, 6), anche se il risultato
    è lo stesso, per far mente locale sui possibili errori che
    si possono commettere]
*/
